/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 * 
 *  Copyright (C) 2008-2015 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id$
 */

/*
 *   sil.hΥ¸ARM-Mѡ
 */

#ifndef TOPPERS_CORE_SIL_H
#define TOPPERS_CORE_SIL_H

#ifndef TOPPERS_MACRO_ONLY

#if __TARGET_ARCH_THUMB == 4
static uint32_t pre_basepri;
#endif /* __TARGET_ARCH_THUMB == 4 */

/*
 *  NMI٤Ƥγߤζػ
 */
Inline bool_t
TOPPERS_disint(void)
{
	uint32_t val;
#if __TARGET_ARCH_THUMB == 4
	Asm("mrs  %0, BASEPRI" : "=r"(val));
	if(val != (1 << (8 - TBITW_IPRI))){
		pre_basepri = val;
		val = (1 << (8 - TBITW_IPRI));
		Asm("msr BASEPRI, %0" : : "r"(val) : "memory");
		return (false);
	} else {
		return (true);
	}
#else /* __TARGET_ARCH_THUMB == 3 */
	Asm("mrs  %0, PRIMASK" : "=r"(val));
	Asm("cpsid i":::"memory");
#endif /* __TARGET_ARCH_THUMB == 4 */

	if (val == 1) {
		return (true);
	}
	else {
		return (false);
	}
}

Inline void
TOPPERS_enaint(bool_t locked)
{
	if (!locked) {
#if __TARGET_ARCH_THUMB == 4
		Asm("msr BASEPRI, %0" : : "r"(pre_basepri) : "memory");
#else /* __TARGET_ARCH_THUMB == 3 */
		Asm("cpsie i":::"memory");
#endif /* __TARGET_ARCH_THUMB == 4 */
	}
}

/*
 *  ߥå֤
 */
#define SIL_PRE_LOC      bool_t  TOPPERS_locked
#define SIL_LOC_INT()    ((void)(TOPPERS_locked = TOPPERS_disint()))
#define SIL_UNL_INT()    (TOPPERS_enaint(TOPPERS_locked))

#endif /* TOPPERS_MACRO_ONLY */

#endif /* TOPPERS_CORE_SIL_H */
