#include <stdio.h>
#include <string.h>
#include "ff.h"
#include "diskio.h"

#define DEF_FATBUFF  1024
char  buff_fattest[ DEF_FATBUFF ];

char  sbuff[64];

#define  DEF_IMAGEBUFF  (128 * 128 * 2)
extern  uint16_t  image_buffer[];

void test_logout( char *msg );


int  fat_test_init( void )
{
    DSTATUS  ret;
    int  result = 0;

    ret = disk_initialize( 0 );
    if( ret & STA_NOINIT ) {
        result = -1;
    }

    return  result;
}


int  fat_test_read( char *filename, char *buff, int bsize )
{
    FRESULT  ret;
    FATFS  fs;
    FIL  fil;
    UINT  rdsz ;

    ret = f_mount( &fs, "", 0 );
    if( ret != FR_OK ) {
        return  -1;
    }
    ret = f_open( &fil, filename, FA_READ );
    if( ret != FR_OK ) {
        return  -2;
    }

    ret = f_read( &fil, buff, (UINT)bsize, &rdsz );
    if( ret != FR_OK ) {
        return  -3;
    }

    f_close( &fil );

    return  (int)rdsz;
}


int  fat_test_write( char *filename, char *buff, int size )
{
    FRESULT  ret;
    FATFS  fs;
    FIL  fil;
    UINT  wsize ;

    ret = f_mount( &fs, "", 1 );
    if( ret != FR_OK ) {
        return  -1;
    }
    ret = f_open( &fil, filename, FA_WRITE|FA_CREATE_ALWAYS );
    if( ret != FR_OK ) {
        return  -2;
    }

    ret = f_write( &fil, buff, (UINT)size, &wsize );
    if( ret != FR_OK ) {
        return  -3;
    }

    f_close( &fil );

    return  (int)wsize;
}

#if 0
int  fat_test_main( void )
{
    int  ret;
    int  i;

    ret = fat_test_init();
    if( ret != 0 ) {
        sprintf( sbuff, "fat_test_init() ERROR, ret = %d\n", ret );
        test_logout( sbuff );
    }

    ret = fat_test_read( "test.txt", buff_fattest, DEF_FATBUFF );
    sprintf( sbuff, "test.txt = %d Byte\n", ret );
    test_logout( sbuff );

    for( i=0 ; i<DEF_DISP_FILE_NUM ; i++ ) {
        ret = fat_test_read( def_img_filename[i], image_buffer, DEF_IMAGEBUFF );
        sprintf( sbuff, "%s = %d Byte\n", def_img_filename[i], ret );
        test_logout( sbuff );
    }

    for( i=0 ; i<DEF_DISP_FILE_NUM ; i++ ) {
        ret = fat_test_read( def_txt_filename[i], buff_fattest, DEF_FATBUFF );
        sprintf( sbuff, "%s = %d Byte\n", def_txt_filename[i], ret );
        test_logout( sbuff );
    }

    return  0;
}
#endif

